package peer

import (
	"encoding/json"

	"cloud.o-forge.io/core/oc-lib/models/utils"
	"github.com/google/uuid"
)

type Peer struct {
	utils.AbstractObject
	Url       string `json:"url,omitempty" bson:"url,omitempty" validate:"required,base64url"`
	PublicKey string `json:"public_key,omitempty" bson:"public_key,omitempty"`
}

func (ao *Peer) GetID() string {
	return ao.UUID
}

func (r *Peer) GenerateID() {
	r.UUID = uuid.New().String()
}

func (d *Peer) GetName() string {
	return d.Name
}

func (d *Peer) GetAccessor() utils.Accessor {
	data := New()
	data.SetLogger(utils.PEER)
	return data
}

func (dma *Peer) Deserialize(j map[string]interface{}) utils.DBObject {
	b, err := json.Marshal(j)
	if err != nil {
		return nil
	}
	json.Unmarshal(b, dma)
	return dma
}

func (dma *Peer) Serialize() map[string]interface{} {
	var m map[string]interface{}
	b, err := json.Marshal(dma)
	if err != nil {
		return nil
	}
	json.Unmarshal(b, &m)
	return m
}
